## sparse 0.6.1

=== Makefile ===
VERSION=0.6.1

########################################################################
# The following variables can be overwritten from the command line
OS = linux


CC = gcc
LD = $(CC)
AR = ar

CFLAGS ?= -O2 -g

DESTDIR ?=
PREFIX ?= $(HOME)
BINDIR ?= $(PREFIX)/bin
MANDIR ?= $(PREFIX)/share/man

PKG_CONFIG ?= pkg-config

CHECKER_FLAGS ?= -Wno-vla

# Allow users to override build settings without dirtying their trees
# For debugging, put this in local.mk:
#
#     CFLAGS += -O0 -DDEBUG -g3 -gdwarf-2
#
SPARSE_LOCAL_CONFIG ?= local.mk
-include ${SPARSE_LOCAL_CONFIG}
########################################################################


LIB_OBJS :=
LIB_OBJS += allocate.o
LIB_OBJS += builtin.o
LIB_OBJS += char.o
LIB_OBJS += compat-$(OS).o
LIB_OBJS += cse.o
LIB_OBJS += dissect.o
LIB_OBJS += dominate.o
LIB_OBJS += evaluate.o
LIB_OBJS += expand.o
LIB_OBJS += expression.o
LIB_OBJS += flow.o
LIB_OBJS += flowgraph.o
LIB_OBJS += inline.o
LIB_OBJS += ir.o
LIB_OBJS += lib.o
LIB_OBJS += linearize.o
LIB_OBJS += liveness.o
LIB_OBJS += memops.o
LIB_OBJS += opcode.o
LIB_OBJS += optimize.o
LIB_OBJS += parse.o
LIB_OBJS += pre-process.o
LIB_OBJS += ptrlist.o
LIB_OBJS += ptrmap.o
LIB_OBJS += scope.o
LIB_OBJS += show-parse.o
LIB_OBJS += simplify.o
LIB_OBJS += sort.o
LIB_OBJS += ssa.o
LIB_OBJS += sset.o
LIB_OBJS += stats.o
LIB_OBJS += storage.o
LIB_OBJS += symbol.o
LIB_OBJS += target.o
LIB_OBJS += tokenize.o
LIB_OBJS += unssa.o
LIB_OBJS += utils.o

PROGRAMS :=
PROGRAMS += compile
PROGRAMS += ctags
PROGRAMS += example
PROGRAMS += graph
PROGRAMS += obfuscate
PROGRAMS += sparse
PROGRAMS += test-dissect
PROGRAMS += test-lexing
PROGRAMS += test-linearize
PROGRAMS += test-parsing
PROGRAMS += test-unssa

INST_PROGRAMS=sparse cgcc
INST_MAN1=sparse.1 cgcc.1


all:

########################################################################
# common flags/options/...

cflags = -fno-strict-aliasing
cflags += -Wall -Wwrite-strings

GCC_BASE := $(shell $(CC) --print-file-name=)
cflags += -DGCC_BASE=\"$(GCC_BASE)\"

MULTIARCH_TRIPLET := $(shell $(CC) -print-multiarch 2>/dev/null)
cflags += -DMULTIARCH_TRIPLET=\"$(MULTIARCH_TRIPLET)\"


bindir := $(DESTDIR)$(BINDIR)
man1dir := $(DESTDIR)$(MANDIR)/man1

########################################################################
# target specificities

compile: compile-i386.o
EXTRA_OBJS += compile-i386.o

# Can we use GCC's generated dependencies?
HAVE_GCC_DEP:=$(shell touch .gcc-test.c && 				\
		$(CC) -c -Wp,-MP,-MMD,.gcc-test.d .gcc-test.c 2>/dev/null && \
		echo 'yes'; rm -f .gcc-test.d .gcc-test.o .gcc-test.c)
ifeq ($(HAVE_GCC_DEP),yes)
cflags += -Wp,-MP,-MMD,$(@D)/.$(@F).d
endif

# Can we use libxml (needed for c2xml)?
HAVE_LIBXML:=$(shell $(PKG_CONFIG) --exists libxml-2.0 2>/dev/null && echo 'yes')
ifeq ($(HAVE_LIBXML),yes)
PROGRAMS+=c2xml
INST_PROGRAMS+=c2xml
c2xml-ldlibs := $(shell $(PKG_CONFIG) --libs libxml-2.0)
c2xml-cflags := $(shell $(PKG_CONFIG) --cflags libxml-2.0)
else
$(warning Your system does not have libxml, disabling c2xml)
endif

# Can we use gtk (needed for test-inspect)
GTK_VERSION:=3.0
HAVE_GTK:=$(shell $(PKG_CONFIG) --exists gtk+-$(GTK_VERSION) 2>/dev/null && echo 'yes')
ifneq ($(HAVE_GTK),yes)
GTK_VERSION:=2.0
HAVE_GTK:=$(shell $(PKG_CONFIG) --exists gtk+-$(GTK_VERSION) 2>/dev/null && echo 'yes')
endif
ifeq ($(HAVE_GTK),yes)
GTK_CFLAGS := $(shell $(PKG_CONFIG) --cflags gtk+-$(GTK_VERSION))
ast-view-cflags := $(GTK_CFLAGS)
ast-model-cflags := $(GTK_CFLAGS)
ast-inspect-cflags := $(GTK_CFLAGS)
test-inspect-cflags := $(GTK_CFLAGS)
test-inspect-ldlibs := $(shell $(PKG_CONFIG) --libs gtk+-$(GTK_VERSION))
test-inspect: ast-model.o ast-view.o ast-inspect.o
EXTRA_OBJS += ast-model.o ast-view.o ast-inspect.o
PROGRAMS += test-inspect
INST_PROGRAMS += test-inspect
else
$(warning Your system does not have gtk3/gtk2, disabling test-inspect)
endif

# Can we use LLVM (needed for ... sparse-llvm)?
LLVM_CONFIG:=llvm-config
HAVE_LLVM:=$(shell $(LLVM_CONFIG) --version >/dev/null 2>&1 && echo 'yes')
ifeq ($(HAVE_LLVM),yes)
arch := $(shell uname -m)
ifeq (${MULTIARCH_TRIPLET},x86_64-linux-gnux32)
arch := x32
endif
ifneq ($(filter ${arch},i386 i486 i586 i686 x86_64 amd64),)
LLVM_VERSION:=$(shell $(LLVM_CONFIG) --version)
ifeq ($(shell expr "$(LLVM_VERSION)" : '[3-9]\.'),2)
LLVM_PROGS := sparse-llvm
$(LLVM_PROGS): LD := g++
LLVM_LDFLAGS := $(shell $(LLVM_CONFIG) --ldflags)
LLVM_CFLAGS := $(shell $(LLVM_CONFIG) --cppflags)
LLVM_LIBS := $(shell $(LLVM_CONFIG) --libs)
LLVM_LIBS += $(shell $(LLVM_CONFIG) --system-libs 2>/dev/null)
LLVM_LIBS += $(shell $(LLVM_CONFIG) --cxxflags | grep -F -q -e '-stdlib=libc++' && echo -lc++)
PROGRAMS += $(LLVM_PROGS)
INST_PROGRAMS += sparse-llvm sparsec
sparse-llvm-cflags := $(LLVM_CFLAGS)
sparse-llvm-ldflags := $(LLVM_LDFLAGS)
sparse-llvm-ldlibs := $(LLVM_LIBS)
else
$(warning LLVM 3.0 or later required. Your system has version $(LLVM_VERSION) installed.)
endif
else
$(warning sparse-llvm disabled on ${arch})
endif
else
$(warning Your system does not have llvm, disabling sparse-llvm)
endif

########################################################################
LIBS := libsparse.a
OBJS := $(LIB_OBJS) $(EXTRA_OBJS) $(PROGRAMS:%=%.o)

# Pretty print
V := @
Q := $(V:1=)

########################################################################
all: $(PROGRAMS)

ldflags += $($(@)-ldflags) $(LDFLAGS)
ldlibs  += $($(@)-ldlibs)  $(LDLIBS)
$(PROGRAMS): % : %.o $(LIBS)
	@echo "  LD      $@"
	$(Q)$(LD) $(ldflags) $^ $(ldlibs) -o $@

libsparse.a: $(LIB_OBJS)
	@echo "  AR      $@"
	$(Q)$(AR) rcs $@ $^


cflags   += $($(*)-cflags) $(CPPFLAGS) $(CFLAGS)
%.o: %.c
	@echo "  CC      $@"
	$(Q)$(CC) $(cflags) -c -o $@ $<

%.sc: %.c sparse
	@echo "  CHECK   $<"
	$(Q)CHECK=./sparse ./cgcc -no-compile $(CHECKER_FLAGS) $(cflags) -c $<

selfcheck: $(OBJS:.o=.sc)


SPARSE_VERSION:=$(shell git describe --dirty 2>/dev/null || echo '$(VERSION)')
lib.o: version.h
version.h: FORCE
	@echo '#define SPARSE_VERSION "$(SPARSE_VERSION)"' > version.h.tmp
	@if cmp -s version.h version.h.tmp; then \
		rm version.h.tmp; \
	else \
		echo "  GEN     $@"; \
		mv version.h.tmp version.h; \
	fi


check: all
	$(Q)cd validation && ./test-suite
validation/%.t: $(PROGRAMS)
	@validation/test-suite single $*.c


clean: clean-check
	@rm -f *.[oa] .*.d $(PROGRAMS) version.h
clean-check:
	@echo "  CLEAN"
	@find validation/ \( -name "*.c.output.*" \
			  -o -name "*.c.error.*" \
			  -o -name "*.o" \
	                  \) -exec rm {} \;


install: install-bin install-man
install-bin: $(INST_PROGRAMS:%=$(bindir)/%)
install-man: $(INST_MAN1:%=$(man1dir)/%)

$(bindir)/%: %
	@echo "  INSTALL $@"
	$(Q)install -D        $< $@ || exit 1;
$(man1dir)/%: %
	@echo "  INSTALL $@"
	$(Q)install -D -m 644 $< $@ || exit 1;

.PHONY: FORCE

# GCC's dependencies
-include $(OBJS:%.o=.%.o.d)

=== debian/changelog ===
sparse (0.6.1-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:15:36 +0100

sparse (0.6.1-2) unstable; urgency=medium

  * Cherry-pick commit from upstream to fix test failures on powerpc and
    mipsel.

 -- Uwe Kleine-König <ukleinek@debian.org>  Thu, 07 Nov 2019 08:37:27 +0100

sparse (0.6.1-1) unstable; urgency=medium

  * New upstream version
    - Several patches are included upstream and were dropped accordingly
      - dd98d9f9bbca ("machine.h: Fix MACH_NATIVE on m68k")
      - 36a74d33c664 ("Makefile: default to LD = CC")
      - a14a1c32f10e ("testsuite: remove unneeded -m64 from command-line")
      - e7a833f32307 ("lib.c: move predefines out of
                       handle_arch_m64_finalize()")
      - 2889393c78c5 ("lib.c: move handle_arch_m64_finalize() to init_target()")
      - 3b246718ea33 ("target.c: ignore -m64 on archs where int32_t is a long")
      - e6e60e370f43 ("predefs: fix for MIPS system headers needing
                       _MIPS_SZ{INT,LONG,PTR}")
      - 949a29adb9f4 ("predefs: add arch-specific predefines")
      - 950e23d1a5af ("cgcc: teach cgcc about Hurd/GNU")
      - 4ba10f29f542 ("validation: Add patterns FAIL, PASS, XPASS and XFAIL to
                       test")
      - b40a6cb5d68b ("fix parallel install")
      - f21358ee7ee7 ("build: honor CFLAGS & friends from environment")
    - Refresh remaining patches
  * Switch to gcc-9 (Closes: #944173)

 -- Uwe Kleine-König <ukleinek@debian.org>  Tue, 05 Nov 2019 21:42:00 +0100

=== debian/control ===
Source: sparse
Maintainer: Uwe Kleine-König <ukleinek@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 12),
               gcc-9,
               libxml2-dev,
               libgtk2.0-dev,
               llvm-dev (>= 1:3.0~) [amd64 i386],
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/ukleinek/sparse.git
Vcs-Browser: https://salsa.debian.org/ukleinek/sparse
Homepage: https://sparse.wiki.kernel.org/
Rules-Requires-Root: no

Package: sparse
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}, gcc-9
Suggests: sparse-test-inspect
Description: semantic parser of source files
 Sparse, the semantic parser, provides a compiler frontend capable of
 parsing most of ANSI C as well as many GCC extensions, and a collection
 of sample compiler backends, including a static analyzer also called
 "sparse". Sparse provides a set of annotations designed to convey
 semantic information about types, such as what address space pointers
 point to, or what locks a function acquires or releases.
 .
 Sparse can be invoked directly as "sparse" or via the "cgcc" wrapper
 around the C compiler.

Package: sparse-test-inspect
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: sparse (<< 0.5.0-2)
Replaces: sparse (<< 0.5.0-2)
Description: semantic parser of source files
 Sparse, the semantic parser, provides a compiler frontend capable of
 parsing most of ANSI C as well as many GCC extensions, and a collection
 of sample compiler backends, including a static analyzer also called
 "sparse". Sparse provides a set of annotations designed to convey
 semantic information about types, such as what address space pointers
 point to, or what locks a function acquires or releases.
 .
 This package contains the test-inspect program.

## sparse 0.6.2

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.6.1
+VERSION=0.6.2
 
 ########################################################################
 # The following variables can be overwritten from the command line
@@ -6,6 +6,7 @@
 
 
 CC = gcc
+CXX = g++
 LD = $(CC)
 AR = ar
 
@@ -65,6 +66,19 @@
 LIB_OBJS += storage.o
 LIB_OBJS += symbol.o
 LIB_OBJS += target.o
+LIB_OBJS += target-alpha.o
+LIB_OBJS += target-arm.o
+LIB_OBJS += target-arm64.o
+LIB_OBJS += target-bfin.o
+LIB_OBJS += target-default.o
+LIB_OBJS += target-m68k.o
+LIB_OBJS += target-mips.o
+LIB_OBJS += target-nios2.o
+LIB_OBJS += target-ppc.o
+LIB_OBJS += target-riscv.o
+LIB_OBJS += target-s390.o
+LIB_OBJS += target-sparc.o
+LIB_OBJS += target-x86.o
 LIB_OBJS += tokenize.o
 LIB_OBJS += unssa.o
 LIB_OBJS += utils.o
@@ -80,6 +94,7 @@
 PROGRAMS += test-lexing
 PROGRAMS += test-linearize
 PROGRAMS += test-parsing
+PROGRAMS += test-show-type
 PROGRAMS += test-unssa
 
 INST_PROGRAMS=sparse cgcc
@@ -127,6 +142,24 @@
 c2xml-cflags := $(shell $(PKG_CONFIG) --cflags libxml-2.0)
 else
 $(warning Your system does not have libxml, disabling c2xml)
+endif
+
+HAVE_SQLITE := $(shell $(PKG_CONFIG) --exists sqlite3 2>/dev/null && echo 'yes')
+ifeq ($(HAVE_SQLITE),yes)
+SQLITE_VERSION:=$(shell $(PKG_CONFIG) --modversion sqlite3)
+SQLITE_VNUMBER:=$(shell printf '%d%02d%02d' $(subst ., ,$(SQLITE_VERSION)))
+ifeq ($(shell expr "$(SQLITE_VNUMBER)" '>=' 32400),1)
+PROGRAMS += sindex
+INST_PROGRAMS += sindex
+INST_MAN1 += sindex.1
+sindex-ldlibs := $(shell $(PKG_CONFIG) --libs sqlite3)
+sindex-cflags := $(shell $(PKG_CONFIG) --cflags sqlite3)
+sindex-cflags += -std=gnu99
+else
+$(warning Your SQLite3 version ($(SQLITE_VERSION)) is too old, 3.24.0 or later is required.)
+endif
+else
+$(warning Your system does not have sqlite3, disabling sindex)
 endif
 
 # Can we use gtk (needed for test-inspect)
@@ -161,9 +194,10 @@
 endif
 ifneq ($(filter ${arch},i386 i486 i586 i686 x86_64 amd64),)
 LLVM_VERSION:=$(shell $(LLVM_CONFIG) --version)
-ifeq ($(shell expr "$(LLVM_VERSION)" : '[3-9]\.'),2)
+LLVM_VERSION_MAJOR:=$(firstword $(subst ., ,$(LLVM_VERSION)))
+ifeq ($(shell expr "$(LLVM_VERSION_MAJOR)" '>=' 3),1)
 LLVM_PROGS := sparse-llvm
-$(LLVM_PROGS): LD := g++
+$(LLVM_PROGS): LD := $(CXX)
 LLVM_LDFLAGS := $(shell $(LLVM_CONFIG) --ldflags)
 LLVM_CFLAGS := $(shell $(LLVM_CONFIG) --cppflags)
 LLVM_LIBS := $(shell $(LLVM_CONFIG) --libs)
@@ -217,7 +251,6 @@
 
 selfcheck: $(OBJS:.o=.sc)
 
-
 SPARSE_VERSION:=$(shell git describe --dirty 2>/dev/null || echo '$(VERSION)')
 lib.o: version.h
 version.h: FORCE

=== debian/changelog ===
sparse (0.6.2-2) unstable; urgency=medium

  * Cherry pick patches from upstream to fix various warnings:
    - cc651aa7b6a0 ("gensel: remove unneeded test/uninitialized warning")
    - eb6779f6f621 ("generic: fix missing inlining of generic expression")
    - 5bbebae38be8 ("fix build on Hurd which doesn't define PATH_MAX")
  * Drop installing sindex which conflicts with biosquid (Closes: #966706)
  * Switch to gtk-3

 -- Uwe Kleine-König <ukleinek@debian.org>  Mon, 03 Aug 2020 21:30:52 +0200

sparse (0.6.2-1) unstable; urgency=medium

  * New upstream version
    Patch "arch: change the arch when changing -m32/64" dropped as this was
    cherry picked from upstream for 0.6.1-2.
  * Switch to debhelper 13
  * Standards-Version: 4.5 (no changes needed)

 -- Uwe Kleine-König <ukleinek@debian.org>  Fri, 31 Jul 2020 23:46:30 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Maintainer: Uwe Kleine-König <ukleinek@debian.org>
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>= 12),
+Build-Depends: debhelper-compat (= 13),
                gcc-9,
                libxml2-dev,
-               libgtk2.0-dev,
+               libgtk-3-dev,
                llvm-dev (>= 1:3.0~) [amd64 i386],
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/ukleinek/sparse.git
 Vcs-Browser: https://salsa.debian.org/ukleinek/sparse
 Homepage: https://sparse.wiki.kernel.org/

## sparse 0.6.3

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.6.2
+VERSION=0.6.3
 
 ########################################################################
 # The following variables can be overwritten from the command line
@@ -52,7 +52,9 @@
 LIB_OBJS += memops.o
 LIB_OBJS += opcode.o
 LIB_OBJS += optimize.o
+LIB_OBJS += options.o
 LIB_OBJS += parse.o
+LIB_OBJS += predefine.o
 LIB_OBJS += pre-process.o
 LIB_OBJS += ptrlist.o
 LIB_OBJS += ptrmap.o
@@ -71,14 +73,20 @@
 LIB_OBJS += target-arm64.o
 LIB_OBJS += target-bfin.o
 LIB_OBJS += target-default.o
+LIB_OBJS += target-h8300.o
 LIB_OBJS += target-m68k.o
+LIB_OBJS += target-microblaze.o
 LIB_OBJS += target-mips.o
+LIB_OBJS += target-nds32.o
 LIB_OBJS += target-nios2.o
+LIB_OBJS += target-openrisc.o
 LIB_OBJS += target-ppc.o
 LIB_OBJS += target-riscv.o
 LIB_OBJS += target-s390.o
+LIB_OBJS += target-sh.o
 LIB_OBJS += target-sparc.o
 LIB_OBJS += target-x86.o
+LIB_OBJS += target-xtensa.o
 LIB_OBJS += tokenize.o
 LIB_OBJS += unssa.o
 LIB_OBJS += utils.o
@@ -149,17 +157,17 @@
 SQLITE_VERSION:=$(shell $(PKG_CONFIG) --modversion sqlite3)
 SQLITE_VNUMBER:=$(shell printf '%d%02d%02d' $(subst ., ,$(SQLITE_VERSION)))
 ifeq ($(shell expr "$(SQLITE_VNUMBER)" '>=' 32400),1)
-PROGRAMS += sindex
-INST_PROGRAMS += sindex
-INST_MAN1 += sindex.1
-sindex-ldlibs := $(shell $(PKG_CONFIG) --libs sqlite3)
-sindex-cflags := $(shell $(PKG_CONFIG) --cflags sqlite3)
-sindex-cflags += -std=gnu99
+PROGRAMS += semind
+INST_PROGRAMS += semind
+INST_MAN1 += semind.1
+semind-ldlibs := $(shell $(PKG_CONFIG) --libs sqlite3)
+semind-cflags := $(shell $(PKG_CONFIG) --cflags sqlite3)
+semind-cflags += -std=gnu99
 else
 $(warning Your SQLite3 version ($(SQLITE_VERSION)) is too old, 3.24.0 or later is required.)
 endif
 else
-$(warning Your system does not have sqlite3, disabling sindex)
+$(warning Your system does not have sqlite3, disabling semind)
 endif
 
 # Can we use gtk (needed for test-inspect)
@@ -265,8 +273,8 @@
 
 check: all
 	$(Q)cd validation && ./test-suite
-validation/%.t: $(PROGRAMS)
-	@validation/test-suite single $*.c
+validation/%: $(PROGRAMS) FORCE
+	$(Q)validation/test-suite $*
 
 
 clean: clean-check

=== debian/changelog ===
sparse (0.6.3-2) unstable; urgency=high

  * Update runtime dependency to gcc-10. (Closes: #982416)
    Thanks to Andrian Bunk for noticing that.

 -- Uwe Kleine-König <ukleinek@debian.org>  Thu, 11 Feb 2021 21:28:50 +0100

sparse (0.6.3-1) unstable; urgency=medium

  * New upstream release
    - all three patches originating from upstream can be dropped as they are
      included in this release.
    - sindex was renamed to semind, so it can be included again (see #966706),
      this adds libsqlite3 to the list of dependencies.
  * Cherry-pick commit to fix crash with llvm11 from upstream.
  * Switch to gcc-10

 -- Uwe Kleine-König <ukleinek@debian.org>  Sun, 08 Nov 2020 22:11:01 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Section: devel
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               gcc-9,
+               gcc-10,
+               libsqlite3-dev,
                libxml2-dev,
                libgtk-3-dev,
                llvm-dev (>= 1:3.0~) [amd64 i386],
@@ -15,7 +16,7 @@
 
 Package: sparse
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}, gcc-9
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}, gcc-10
 Suggests: sparse-test-inspect
 Description: semantic parser of source files
  Sparse, the semantic parser, provides a compiler frontend capable of

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk

DH_MAKE_ARGS = SPARSE_VERSION="\$$(VERSION) ($(DEB_VENDOR): $(DEB_VERSION))" PREFIX=/usr

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
DH_MAKE_ARGS += V=1
endif

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(DH_MAKE_ARGS)

override_dh_auto_test:
	dh_auto_test -- $(DH_MAKE_ARGS)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	printf 'uname -m: %s\ngcc -dumpmachine: %s\n' $$(uname -m) $$(gcc -dumpmachine)
# test for missing cpp symbols to compile hosted programs
	env CHECK=./sparse ./cgcc -no-compile memops.c
endif

override_dh_auto_install:
	dh_auto_install -- $(DH_MAKE_ARGS)

=== debian/watch ===
version=3
https://git.kernel.org/pub/scm/devel/sparse/sparse.git/refs/tags \
	/pub/scm/devel/sparse/sparse.git/snapshot/sparse-([\d.]+).tar.gz

## sparse 0.6.4

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.6.3
+VERSION=0.6.4
 
 ########################################################################
 # The following variables can be overwritten from the command line
@@ -63,7 +63,6 @@
 LIB_OBJS += simplify.o
 LIB_OBJS += sort.o
 LIB_OBJS += ssa.o
-LIB_OBJS += sset.o
 LIB_OBJS += stats.o
 LIB_OBJS += storage.o
 LIB_OBJS += symbol.o
@@ -90,6 +89,7 @@
 LIB_OBJS += tokenize.o
 LIB_OBJS += unssa.o
 LIB_OBJS += utils.o
+LIB_OBJS += version.o
 
 PROGRAMS :=
 PROGRAMS += compile
@@ -226,6 +226,13 @@
 $(warning Your system does not have llvm, disabling sparse-llvm)
 endif
 
+ifeq ($(HAVE_BOOLECTOR),yes)
+PROGRAMS += scheck
+scheck-cflags  := -I${BOOLECTORDIR}/include/boolector
+scheck-ldflags := -L${BOOLECTORDIR}/lib
+scheck-ldlibs  := -lboolector -llgl -lbtor2parser
+endif
+
 ########################################################################
 LIBS := libsparse.a
 OBJS := $(LIB_OBJS) $(EXTRA_OBJS) $(PROGRAMS:%=%.o)
@@ -260,7 +267,7 @@
 selfcheck: $(OBJS:.o=.sc)
 
 SPARSE_VERSION:=$(shell git describe --dirty 2>/dev/null || echo '$(VERSION)')
-lib.o: version.h
+version.o: version.h
 version.h: FORCE
 	@echo '#define SPARSE_VERSION "$(SPARSE_VERSION)"' > version.h.tmp
 	@if cmp -s version.h version.h.tmp; then \

=== Documentation/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    = -a
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = sparse
SOURCEDIR     = .
BUILDDIR      = build

targets := help
targets += html
targets += man


# Put it first so that "make" without argument is like "make help".
help:

# route all targets to Sphinx using the new "make mode" option.
$(targets): conf.py Makefile
	@$(SPHINXBUILD) -M  $@  "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS)

%.1: %.rst man
	@mv build/man/$@ $@

.PHONY: Makefile	# avoid circular deps with the catch-all rule

=== debian/changelog ===
sparse (0.6.4-5ubuntu1) plucky; urgency=medium

  * Merge from Debian Unstable. Remaining changes:
    - d/rules: enable llvm build.
    - d/p/llvm-15-*: add LLVM 15 support upstream patches
      (launchpad bug 2009524).
  * Dropped changes, included in Debian:
    - d/p/linearize-fix-buffer-overrun.patch: add upstream patch to
      fix buffer overrun warning (LP: #2055113).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 19 Feb 2025 22:16:01 -0600

sparse (0.6.4-5) unstable; urgency=medium

  [ Diederik de Haas ]
  * Switch to gcc-14 (Closes: #1090950)
  * Bump Standards-Version to 4.7.0 (no changes required)
  * Cherry pick upstream commit to fix buffer overrun (Closes: #1065020)

 -- Uwe Kleine-König <ukleinek@debian.org>  Sat, 21 Dec 2024 09:27:30 +0100

sparse (0.6.4-4ubuntu1) noble; urgency=medium

  * Merge with Debian unstable (LP: #2054991).
  * Dropped Changes:
    - debian/patches/support-llvm-15.patch: fix LLVM 15 warnings,
      update call generation (launchpad bug 2009524).
  * New Changes:
    - d/rules: enable llvm build.
    - d/p/llvm-15-*: add LLVM 15 support upstream patches
      (launchpad bug 2009524).
    - d/p/linearize-fix-buffer-overrun.patch: add upstream patch to
      fix buffer overrun warning (LP: #2055113).

 -- Vladimir Petko <vladimir.petko@canonical.com>  Tue, 27 Feb 2024 17:30:03 +1300

sparse (0.6.4-4) unstable; urgency=medium

  * Disable llvm support as it fails to compile with llvm >= 16 (Closes:
    #1051864)
  * Switch to gcc-13
  * Bump Standards-Version (no changes required)

 -- Uwe Kleine-König <ukleinek@debian.org>  Sun, 24 Sep 2023 00:46:14 +0200

sparse (0.6.4-3ubuntu1) lunar; urgency=medium

  * debian/patches/support-llvm-15.patch: fix LLVM 15 warnings, update call
    generation (LP: #2009524).

 -- Vladimir Petko <vladimir.petko@canonical.com>  Tue, 07 Mar 2023 08:08:17 +1300

sparse (0.6.4-3) unstable; urgency=medium

  * Switch to gcc-12
  * Cherry pick commit from upstream to fix "unreplaced" warnings
  * Bump Standards-Version (no changes required)

 -- Uwe Kleine-König <ukleinek@debian.org>  Mon, 12 Sep 2022 10:08:08 +0200

sparse (0.6.4-2) unstable; urgency=medium

  * Switch to gcc-11 (Closes: #1008580)

 -- Uwe Kleine-König <ukleinek@debian.org>  Wed, 30 Mar 2022 10:20:07 +0200

sparse (0.6.4-1) unstable; urgency=medium

  * New upstream release
    One fix that was cherry picked from upstream for 0.6.3-1 could be dropped.
  * Bump Standards-Version (no changes required)

 -- Uwe Kleine-König <ukleinek@debian.org>  Mon, 27 Sep 2021 22:22:58 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: sparse
-Maintainer: Uwe Kleine-König <ukleinek@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Uwe Kleine-König <ukleinek@debian.org>
 Section: devel
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               gcc-10,
+               gcc-14,
                libsqlite3-dev,
                libxml2-dev,
                libgtk-3-dev,
-               llvm-dev (>= 1:3.0~) [amd64 i386],
-Standards-Version: 4.5.0
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/ukleinek/sparse.git
 Vcs-Browser: https://salsa.debian.org/ukleinek/sparse
 Homepage: https://sparse.wiki.kernel.org/
@@ -16,7 +16,7 @@
 
 Package: sparse
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}, gcc-10
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}, gcc-14
 Suggests: sparse-test-inspect
 Description: semantic parser of source files
  Sparse, the semantic parser, provides a compiler frontend capable of

=== debian/watch ===
version=4
https://git.kernel.org/pub/scm/devel/sparse/sparse.git/refs/tags \
	/pub/scm/devel/sparse/sparse.git/snapshot/sparse-([\d.]+).tar.gz

## sparse 0.6.5~rc1

=== Makefile ===
--- 
+++ 
@@ -200,7 +200,7 @@
 ifeq (${MULTIARCH_TRIPLET},x86_64-linux-gnux32)
 arch := x32
 endif
-ifneq ($(filter ${arch},i386 i486 i586 i686 x86_64 amd64),)
+ifneq ($(filter ${arch},i386 i486 i586 i686 x86_64 amd64 aarch64 arm64),)
 LLVM_VERSION:=$(shell $(LLVM_CONFIG) --version)
 LLVM_VERSION_MAJOR:=$(firstword $(subst ., ,$(LLVM_VERSION)))
 ifeq ($(shell expr "$(LLVM_VERSION_MAJOR)" '>=' 3),1)
@@ -216,6 +216,9 @@
 sparse-llvm-cflags := $(LLVM_CFLAGS)
 sparse-llvm-ldflags := $(LLVM_LDFLAGS)
 sparse-llvm-ldlibs := $(LLVM_LIBS)
+ifeq ($(LLVM_VERSION_MAJOR),14)
+sparse-llvm-cflags += -Wno-deprecated-declarations
+endif
 else
 $(warning LLVM 3.0 or later required. Your system has version $(LLVM_VERSION) installed.)
 endif

=== debian/changelog ===
sparse (0.6.5~rc1-1) unstable; urgency=medium

  * Switch to gcc-15 (Closes: #1129515)
  * New upstream release candidate (Closes: #1129551)
  * Bump Standards-Version to 4.7.3
    - Drop Priority field for source package

 -- Uwe Kleine-König <ukleinek@debian.org>  Tue, 03 Mar 2026 10:17:53 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,12 @@
 Source: sparse
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Uwe Kleine-König <ukleinek@debian.org>
+Maintainer: Uwe Kleine-König <ukleinek@debian.org>
 Section: devel
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               gcc-14,
+               gcc-15,
                libsqlite3-dev,
                libxml2-dev,
                libgtk-3-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Git: https://salsa.debian.org/ukleinek/sparse.git
 Vcs-Browser: https://salsa.debian.org/ukleinek/sparse
 Homepage: https://sparse.wiki.kernel.org/
@@ -16,7 +14,7 @@
 
 Package: sparse
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}, gcc-14
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}, gcc-15
 Suggests: sparse-test-inspect
 Description: semantic parser of source files
  Sparse, the semantic parser, provides a compiler frontend capable of

## sparse lut-1.0.0

=== requirements.txt ===
ordered-set>=1.0
tqdm>=1.0
networkx>=2.0
matplotlib
